"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const url_1 = require("url");
function listen(server, ...args) {
    return new Promise((resolve, reject) => {
        args.push((err) => {
            if (err)
                return reject(err);
            const addressInfo = server.address();
            if (typeof addressInfo === 'string') {
                resolve(addressInfo);
            }
            else {
                // TODO: detect protocol type based on `server` shape
                const protocol = 'http:';
                const { address: hostname, port } = addressInfo;
                const url = url_1.format({ protocol, hostname, port });
                resolve(Object.assign({ url }, addressInfo));
            }
        });
        server.listen(...args);
    });
}
exports.default = listen;
//# sourceMappingURL=index.js.map